Option Explicit 

' vbslib  ver3.00+
' Copyright (c) 2008-2009, T's-Neko at Sage Plaisir 21 (Japan)
' All rights reserved. Based on 3-clause BSD license.

Dim  g_SrcPath
Dim  g_vbslib_network_Path
     g_vbslib_network_Path = g_SrcPath


 
'********************************************************************************
'  <<< [SetVirtualFileServer] >>> 
'********************************************************************************
Sub  SetVirtualFileServer( VirtualURL, LocalPath )
  echo  ">SetVirtualFileServer  """+ VirtualURL +""", """+ LocalPath +""""

  Dim  sv : Set sv = get_VirtualServerAtLocal()
  Dim  fo : Set fo = new VirtualFileFolder

  sv.m_VirtualFolders.Add  fo
  fo.m_BaseURL = VirtualURL
  fo.m_VirtualFileLocalPath = LocalPath
End Sub


 
'********************************************************************************
'  <<< [DownloadByHttp] >>> 
'********************************************************************************
Sub  DownloadByHttp( DownloadURL, OutLocalPath )
  Dim  sv : Set sv = get_VirtualServerAtLocal()

  echo_flush
  echo_r  ">DownloadByHttp  """+ DownloadURL +""", """+ OutLocalPath +"""", ""

  If Left( DownloadURL, 7 ) <> "http://" Then  Error

  g_AppKey.AddNewWritableFolder  OutLocalPath

  If sv.IsVirtual( DownloadURL ) Then
    copy  sv.GetLocalPath( DownloadURL ), OutLocalPath
  Else
    Dim  http, stream, e, b_manual

    Set http = WScript.CreateObject( "MSXML2.XMLHTTP" )  '// from Internet Explorer 6
    http.Open  "GET", GetPercentURL( DownloadURL ), False

    If TryStart(e) Then  On Error Resume Next
      http.Send
    If TryEnd Then  On Error GoTo 0
    b_manual = False
    If e.num = &h800C0005  Then  b_manual = True : e.Clear
    If e.num <> 0 Then  e.Raise

    If b_manual Then
      echo  ""
      echo  "t@CA[EH[邽߁A̕@Ń_E[h܂B"
      Do
        echo  ""
        echo  "  "+ DownloadURL
        echo  ""
        echo  "_E[hJn܂Bt@C͉LɕۑĂB"
        echo  ""
        echo  "  "+ GetAbsPath( OutLocalPath, Empty )
        echo  ""
        pause
        start  "explorer  """+ DownloadURL +""""
        input  "ۑł Enter ĂB"
        If exist( OutLocalPath ) Then  Exit Do
      Loop
    Else
      Set stream = WScript.CreateObject( "Adodb.Stream" )
      stream.Type = 1 '// 1=adTypeBinary
      stream.Open
      stream.Write  http.ResponseBody

      stream.SaveToFile  OutLocalPath, 2  '// 2=adSaveCreateOverWrite
    End If
  End If
  echo_r  "Download Completed.", ""
End Sub


 
'********************************************************************************
'  <<< [GetPercentURL] >>> 
'********************************************************************************
Function  GetPercentURL( UnicodeURL )
  Dim  c, cc, i


  '//=== Skip to ":"
  i = 1
  Do
    c = Mid( UnicodeURL, i, 1 )
    If c = "" Then  Error
    If c = ":" Then  Exit Do
    i=i+1
  Loop


  '//=== Skip to not "/"
  i=i+1
  Do
    c = Mid( UnicodeURL, i, 1 )
    If c <> "/" Then  Exit Do
    i=i+1
  Loop

  GetPercentURL = Left( UnicodeURL, i-1 )


  '//=== Replace to percent escape
  Do
    c = Mid( UnicodeURL, i, 1 )
    If c = "" Then  Exit Do

    If c >= " "  and  c <= "~" Then
      cc = g_PercentURLTable( Asc( c ) - &h20 )
    Else
      cc = "%" + Hex( Asc( c ) )
    End If

    GetPercentURL = GetPercentURL + cc
    i=i+1
  Loop
End Function


Dim  g_PercentURLTable : g_PercentURLTable = Array(_
  "%20", "!", "%22", "%23", "$", "%", "&", "'", "(", ")", "*", "+", ",", "-", ".", "/", _
  "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", ":", ";", "%3C", "=", "%3E", "?", _
  "@", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", _
  "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "%5B", "%5C", "%5D", "%5E", "_", _
  "%60", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", _
  "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "%7B", "%7C", "%7D", "~" )


 
'-------------------------------------------------------------------------
' ### <<<< [VirtualServerAtLocal] Class >>>> 
'-------------------------------------------------------------------------
Class  VirtualServerAtLocal
  Public  m_VirtualFolders  ' as ArrayClass

  Private Sub Class_Initialize()
    Set m_VirtualFolders = new ArrayClass
  End Sub

  Public Function  GetLocalPath( URL )
    Dim  fo
    For Each fo  In m_VirtualFolders.m_Array
      If Left( URL, Len( fo.m_BaseURL ) ) = fo.m_BaseURL Then
        GetLocalPath = Replace( URL, fo.m_BaseURL, fo.m_VirtualFileLocalPath )
        Exit Function
      End If
    Next
    Raise  E_PathNotFound, _
        "<ERROR msg=""w URL ̉zt@CET[o[ݒ肳Ă܂"" url="""+_
        src +"""/>"
  End Function

  Public Function  IsVirtual( URL )
    Dim  fo
    For Each fo  In m_VirtualFolders.m_Array
      If Left( URL, Len( fo.m_BaseURL ) ) = fo.m_BaseURL Then
        IsVirtual = True : Exit Function
      End If
    Next
    IsVirtual = False
  End Function
End Class


Class  VirtualFileFolder
  Public  m_BaseURL  ' as string
  Public  m_VirtualFileLocalPath  ' as string
End Class


Function    get_VirtualServerAtLocal()  '// has_interface_of ClassI
  If IsEmpty( g_VirtualServerAtLocal ) Then _
    Set g_VirtualServerAtLocal = new VirtualServerAtLocal : ErrCheck
  Set get_VirtualServerAtLocal =   g_VirtualServerAtLocal
End Function

Dim  g_VirtualServerAtLocal


 
